#ifndef __GMT_LINKED__H__
#define __GMT_LINKED__H__

#include "gmt_objtype.h"

// GMT Object Linked List 클레스, 링크드 리스트는 이곳에서 관리 된다.
class GMTOBJLINKEDLIST
{

private:
    unsigned nTotalNode;                                                                  // 총 등록 되어진 노드의 갯수
    GMTOBJECT root;                                                                         // 링크드 리스트의 시작 점
    GMTOBJECT tail;                                                                          // 링크드 리스트의 끝 점

public:
    void InitList(void);                                                                  // 링크드 리스트 초기화 루틴
    unsigned int InsertData(GMTOBJECT *node);                                  // 데이터 등록 함수
    GMTOBJECT* GetRootData(void);                                                 // 루트의 다음 데이터를 구해 냅니다.
    GMTOBJECT* GetTailData(void);                                                   // 테일의 주소를 구해 냅니다.
    void PushData(GMTOBJECT *node);                                               // 데이터를 Push 하는 함수
    GMTOBJECT* PopData(void);                                                        // 데이터를 Pop 하는 함수
    void AllMakeList(GMTOBJECT *node);                                           // 모든 링크드 리스트를 저장해 둡니다.

};

// GMT Group Linked List 클레스, 그룹화된 링크드 리스트는 이곳에서 관리 됩니다.
class GMTGROUPLINKEDLIST
{

private:
    unsigned nTotalNode;                                                            // 총 등록되어진 그룹 노드의 갯수
    GMTGROUP root;                                                                  // 링크드 리스트의 시작 점
    GMTGROUP tail;                                                                   // 링크드 리스트의 끝 점

public:
    void InitList(void);                                                                  // 링크드 리스트 초기화 루틴
    unsigned int InsertData(GMTGROUP *node);                                  // 데이터 등록 함수
    GMTGROUP* GetRootData(void);                                                 // 루트의 다음 데이터를 구해 냅니다.
    GMTGROUP* GetTailData(void);                                                   // 테일의 주소를 구해 냅니다.
    void PushData(GMTGROUP *node);                                               // 데이터를 Push 하는 함수
    GMTGROUP* PopData(void);                                                        // 데이터를 Pop 하는 함수
    void AllMakeList(GMTGROUP *node);                                           // 모든 링크드 리스트를 저장해 둡니다.

};

#endif
