#ifndef __GMT_STRUCT__H__
#define __GMT_STRUCT__H__

#define GMT_MAX_OBJECT  65535

#define GMT_OK              0x01
#define GMT_ERROR        -0x01

// GMT_Rect 구조체, 위치 좌표를 저장하기 위해 존재.
union GMT_Rect
{

    struct
    {

        unsigned short int x;
        unsigned short int y;
        unsigned short int w;
        unsigned short int h;

    };

    unsigned short int data[4];

};

// GMT_Color 구조체, 색상 정보를 저장하기 위해 존재
union GMT_Color
{

    struct
    {

        unsigned char r;
        unsigned char g;
        unsigned char b;
        unsigned char a;

    };

    unsigned int rgba;

};

// GMT_Image 구조체, 이미지 정보를 저장하기 위해 존재
struct GMT_Image
{

    unsigned int imgWidth;
    unsigned int imgHeight;
    unsigned char bpp;

    unsigned char *pixels;

};

#endif
