//===========================================================
//
//  Game Maker Tools - GMT_init.cpp
//
//  - gmt_init.cpp  ʱȭ /  ƾ  ֽϴ.
//
//===========================================================

#include "./../header/gmt.h"

// ⺻ Ȯ Լ ͵ Ǿ ִٰ Ѵ.
extern PFNGLBLENDCOLOREXTPROC glBlendColorEXT;
extern PFNGLWINDOWPOS2IARBPROC glWindowPos2iARB;

// ٸ   GMTSystem Ŭ.
extern GMTSYSTEM *GMTSystem;

//==========================================================================================
//
// GMTSYSTEM Ŭ κ
//
//==========================================================================================

// ڿ Ҹ, ū ǹ̴ .
GMTSYSTEM::GMTSYSTEM()
{
}

GMTSYSTEM::~GMTSYSTEM()
{
}

// GMTSYSTEM ʱȭ ƾ
void GMTSYSTEM::InitSystem(void)
{

    //     0 ϴ.
    memset(this, 0, sizeof(*this));

    // SDL ʱȭ մϴ.
    if((SDL_Init(SDL_INIT_VIDEO | SDL_INIT_TIMER)))
        GMT_Perror("\nSDL_Init Լ  ߻ ߽ϴ.");

    // SDL_ttf  ʱȭ մϴ.
    if((TTF_Init()))
        GMT_Perror("\nSDL_ttf ʱȭ  ߽ϴ.");

    // Ʈ ý ʱȭ մϴ.
    ObjSystem.InitSystem();

    // fps   غ մϴ. 1ʴ ѹ Ǵ Ÿ̸Ӹ ϴ.
    if(!SDL_AddTimer(1000, TimerFunc, &FPS))
        GMT_Perror("\nSDL  Ÿ̸Ӹ  ߽ϴ.");

    FPS.fpscounter = 0;
    FPS.nfps = 0;

}

// GMTSYSTEM  ƾ
void GMTSYSTEM::QuitSystem(void)
{

    // SDL  ƾ
    TTF_Quit();
    SDL_Quit();

}

//==========================================================================================
//
// GMTOBJECTSYSTEM Ŭ κ
//
//==========================================================================================

// GMTOBJECTSYSTEM ý ʱȭ Լ
void GMTOBJECTSYSTEM::InitSystem(void)
{

    // ũ Ʈ ʱȭ մϴ.
    ProcList.InitList();
    GroupList.InitList();

    EmptyList.InitList();
    EmptyGroupList.InitList();

    //  ũ Ʈ  Ӵϴ.
    EmptyList.AllMakeList(node);
    EmptyGroupList.AllMakeList(gnode);

    // ⺻ Ʈ ũ 22 Ʈ Դϴ.
    FontSize = 22;

    // Ʈ ʱȭ մϴ.
    if(!(font = TTF_OpenFont("./Data/fonts/Eunjin.ttf", FontSize)))
        GMT_Perror("font ε忡  ߽ϴ.");

}

//==========================================================================================
//
// GMTOBJLINKEDLIST Ŭ κ
//
//==========================================================================================

// ũ Ʈ ʱȭ ƾ
void GMTOBJLINKEDLIST::InitList(void)
{

    root.next = &tail;
    root.prev = &tail;

    tail.next = &root;
    tail.prev = &root;

}

//==========================================================================================
//
// GMTGROUPLINKEDLIST Ŭ κ
//
//==========================================================================================


void GMTGROUPLINKEDLIST::InitList(void)
{

    root.next = &tail;
    root.prev = &tail;

    tail.next = &root;
    tail.prev = &root;

}

//==========================================================================================
//
// GMT  Լ 
//
//==========================================================================================

// GMT ʱȭ ƾ
int GMT_Init(void)
{

    printf("GMT System ʱȭ .....");

    //  GMTSystem  Ҵ մϴ.
    GMTSystem = (GMTSYSTEM*)malloc(sizeof(GMTSYSTEM));

    if(!GMTSystem)
    {

        GMT_Perror("GMTSystem ʱȭ  ߽ϴ.");
        return GMT_ERROR;

    }

    // GMTSystem ʱȭ ƾ ȣ մϴ.
    GMTSystem->InitSystem();

    printf("Ϸ\n");

    return GMT_OK;

}

// GMT  ƾ
void GMT_Quit(void)
{

    // GMT Ŭ  ƾ ȣ
    GMTSystem->QuitSystem();

}

// GMT   ƾ
void GMT_CreateWindow(unsigned short int w, unsigned short int h, unsigned char bpp)
{

// ũ   ȭ  մϴ.
GMTSystem->
#ifdef WIN32
    CreateWindows
#else
    CreateWindow
#endif
    (w, h, bpp);

    // OpenGL  Ȯ ϴ Լ
    printf("\nOpenGL ʱȭ  =======\n");
    printf("OpenGL %s\n\n", (GLubyte*)glGetString(GL_VERSION));
    printf("Extension List -------------------\n%s\n", (GLubyte*)glGetString(GL_EXTENSIONS));
    printf("\nOpenGL Ȯ ʱȭ  =======\n");

    // ʿ Լ   Ȯ Ѵ.
    // OpenGL Extension   Լ
    printf("glBlendColor Լ Ȯ .....");

    #ifdef WIN32
        glBlendColorEXT = (PFNGLBLENDCOLOREXTPROC)wglGetProcAddress("glBlendColorEXT");
    #else
        glBlendColorEXT = (PFNGLBLENDCOLOREXTPROC)glXGetProcAddress((GLubyte*)"glBlendColorEXT");
    #endif

    if( !glBlendColorEXT )
        printf("glBlendColorEXT Ȯ  ʽϴ. ٸ Լ ü ˴ϴ.\n");

    printf("Ϸ!\n");

    // OpenGL Extension   Լ
    printf("glWindowPos Լ Ȯ .....");

    #ifdef WIN32
        glWindowPos2iARB = (PFNGLWINDOWPOS2IARBPROC)wglGetProcAddress("glWindowPos2iARB");
    #else
        glWindowPos2iARB = (PFNGLWINDOWPOS2IARBPROC)glXGetProcAddress((GLubyte*)"glWindowPos2iARB");
    #endif

    if( !glWindowPos2iARB )
        printf("glWindowPos2iARB Ȯ  ʽϴ. ٸ Լ ü ˴ϴ.\n");

    glBlendColorEXT = 0;

    printf("Ϸ!\n");

}
