#ifndef __GMT_MODULE__H__
#define __GMT_MODULE__H__

// GMT 모듈 구조체는 기존의 오브젝트나 GMT 자체에서 사용하게 될 외부 모듈을 적재할 방법을 제시합니다.
// 각 오브젝트들은 자신들이 가지는 이벤트 모듈 또는 이벤트 스크립트를 가지게 됩니다.
// 여기서는 모듈들이 구현되어 집니다.
// 단, 현재로서 외부 모듈 부분은 리눅스에서만 구동 가능합니다.

// 모듈의 이벤트 종류
#define GMT_MODULE_ONOVER           0x0001
#define GMT_MODULE_ONCLICK          0x0002
#define GMT_MODULE_ONOUT             0x0004

// GMT_MODULE_GetObject 에서 사용될 반환 인자
#define GMT_OBJ_ID            0x0000
#define GMT_OBJ_TYPE        0x0001
#define GMT_OBJ_OBJECT    0x0002

// GMT_MODULE_GetObject 에서 사용될 반환 옵션
#define GMT_MYSELF          0x0000
#define GMT_OTHER            0x0001

// 모듈 구조체
typedef void(*MODULE)(void);

// 각 상황별 모듈들을 적재할 수 있습니다.
struct EVENTMODULE
{

    // 마우스와 오브젝트의 관계
    MODULE OnOver;                              // 마우스가 위로 올라왔을시 호출
    MODULE OnClick;                              // 마우스가 클릭 되었을시 호출
    MODULE OnOut;                               // 마우스가 다른 곳으로 갔을시 호출

};

#endif
