#include "GMT/header/gmt.h"

// 모듈 테스트 용
void ButtonOver(void)
{

    unsigned int nID;

    GMT_MODULE_GetObject(GMT_OBJ_ID, GMT_MYSELF, &nID);

    printf("%d 적재된 모듈 테스트, 마우스 오버!\n", nID);

    // 라벨 값을 바꿔보자
    GMT_SetLabel(nID, "오버!");

    unsigned int nOtherID;

    // 자신을 제외한 다른 모든 객체에 대해 구해보자!
    GMT_MODULE_GetObject(GMT_OBJ_ID, GMT_OTHER, &nOtherID);

    GMT_SetLabel(nOtherID, "나는!");

}

void ButtonClick(void)
{

    unsigned int nID;

    GMT_MODULE_GetObject(GMT_OBJ_ID, GMT_MYSELF, &nID);

    printf("%d 적재된 모듈 테스트, 마우스 클릭!\n", nID);

    GMT_SetLabel(nID, "클릭!");

    unsigned int nOtherID;

    // 자신을 제외한 다른 모든 객체에 대해 구해보자!
    GMT_MODULE_GetObject(GMT_OBJ_ID, GMT_OTHER, &nOtherID);

    GMT_SetLabel(nOtherID, "나도!");

}

void ButtonOut(void)
{

    unsigned int nID;

    GMT_MODULE_GetObject(GMT_OBJ_ID, GMT_MYSELF, &nID);

    printf("%d 적재된 모듈 테스트, 마우스 아웃!\n", nID);

    GMT_SetLabel(nID, "");

    unsigned int nOtherID;

    // 자신을 제외한 다른 모든 객체에 대해 구해보자!
    GMT_MODULE_GetObject(GMT_OBJ_ID, GMT_OTHER, &nOtherID);

    GMT_SetLabel(nOtherID, "");

}

int main(int argc, char *argv[])
{

    #ifdef WIN32

        const char * confile = "CONOUT$";

        FreeConsole();
        if(  !AllocConsole() )
        {
            // handle error
        }

        freopen(confile, "w", stdout);
        freopen(confile, "w", stderr);

    #endif

    SDL_Event event;
    unsigned int Group1;
    unsigned int List, Button[3];
    bool done = false;

    // GMT 시스템을 초기화 합니다.
    GMT_Init();

    // GMT 시스템 윈도우를 생성 합니다.
    GMT_CreateWindow(800, 600, 32);

    // 윈도우의 이름을 변경 합니다.
    GMT_SetCaption("Game Maker Tools");

    // 화면을 지울 색상을 저장 한다.
    GMT_ClearColor(255, 255, 0, 0);

    Group1 = GMT_CreateGroup();

    Button[0] = GMT_CreateButton(10, 110, 250, 250);
    Button[1] = GMT_CreateButton(270, 110, 250, 250);
    Button[2] = GMT_CreateButton(530, 110, 250, 250);

    GMT_SetGroup(Group1, Button[0]);
    GMT_SetGroup(Group1, Button[1]);
    GMT_SetGroup(Group1, Button[2]);

    GMT_SetButtonImg(Group1, "./Data/Image/game.png", "./Data/Image/game2.png", "./Data/Image/game3.png");
    GMT_SetButtonImg(Button[1], "./Data/Image/robot.png", "./Data/Image/robot2.png", "./Data/Image/robot3.png");
    GMT_SetButtonImg(Button[2], "./Data/Image/toys.png", "./Data/Image/toys2.png", "./Data/Image/toys3.png");
    GMT_SetAbleAlpha(Group1, GMT_ABLE);
    GMT_SetButtonAlpha(Group1, 255, 200, 100);

    // 테스트 용으로 오브젝트에 모듈을 적재해 보자.
    GMT_SetModule(Group1, GMT_MODULE_ONOVER, ButtonOver);
    GMT_SetModule(Group1, GMT_MODULE_ONCLICK, ButtonClick);
    GMT_SetModule(Group1, GMT_MODULE_ONOUT, ButtonOut);

    // 메인 루프 돈다.
    while( !done )
    {

        // GMT_ClearScreen 함수로 화면을 원하는 색상으로 지운다.
        GMT_ClearScreen();

        // GMT_GetEvent 함수로 이벤트를 구해 온다.
        while( GMT_GetEvent( &event ) )
        {

            switch( event.type )
            {

                case SDL_QUIT:

                    done = true;

                break;

            }

        }

        // 화면을 재 갱신한다.
        GMT_Flip();

    }

    // GMT 시스템을 종료 합니다.
    GMT_Quit();

    return 0;

}

